import { executeQuery } from '../Connection/QueriesExecutor.js'

const getClients = async function (body) {
    let sql = process.env.usa_instituicao_cliente_filial === 'S' ? 'GET_CLIENTS_SAPORE' : 'GET_CLIENTS'

    const result = await executeQuery({ sql,
        rawReturn: true
    })

    return result
}

const getStates = async function (body) {
    const binds = {...body}
    const result = await executeQuery({sql: 'GET_STATES',
    rawReturn: true,
    binds })
    return result
}

const getCities = async function (body) {
    const binds = {...body}
    delete binds.FIRST
    delete binds.LAST
    const result = await executeQuery({sql: 'GET_CITIES',
    rawReturn: true,
    binds })
    return result
}

const registerUser = async function (body) {
    try {
        const binds = { ...body }
        const result = await executeQuery({sql: 'REGISTER_USER',
            rawReturn: true,
            binds })
        return result
    } catch (error) {
        throw error
    }
}

const getCDTIPOCONS = async function (CDFILIAL) {
    const result = await executeQuery({sql: 'GET_TIPO_CONS',
    rawReturn: true,
    binds: {
        CDFILIAL
    }})
    return (result && result[0] && result[0].CDTIPOCONS) || ''
}

const getCDCCUSCLIE = async function (CDFILIAL) {
    const result = await executeQuery({sql: 'GET_CUS_CLIE',
    rawReturn: true,
    binds: {
        CDFILIAL
    }})

    return (result && result[0] && result[0].CDCCUSCLIE) || ''
}

const getConsumerByLogin = async function (body) {
    const binds = {...body}
    const result = await executeQuery({sql: 'GET_CONSUMER_BY_USERNAME',
    rawReturn: true,
    binds })
    return result
}

const getConsumerByCPF = async function (body) {
    const binds = {...body}
    const result = await executeQuery({sql: 'GET_CONSUMER_BY_CPF',
    rawReturn: true,
    binds })
    return result
}

const getConsumerById = async function (CDIDCONSUMID, CDCLIENTE) {
    const result = await executeQuery({sql: 'GET_CONSUMER_BY_ID',
    rawReturn: true,
    binds: {
        CDIDCONSUMID,
        CDCLIENTE
    }})
    return result
}
const getConsumerByCdConsumidor = async function (CDCLIENTE, CDCONSUMIDOR) {
    const result = await executeQuery({sql: 'GET_CONSUMER_BY_CODIGO',
    rawReturn: true,
    binds: {
        CDCLIENTE,
        CDCONSUMIDOR
    }})
    return result && result[0]
}
const getNewCode = async function (body) {
    const binds = { ...body }
    const result = await executeQuery({
    rawReturn: true,
    binds,
    newCode: true })
    return result
}
export default { getClients, getStates, getCities, registerUser, getCDTIPOCONS, getCDCCUSCLIE, getConsumerByLogin, getConsumerById, getConsumerByCPF, getNewCode, getConsumerByCdConsumidor}
